/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Origine des sources :
    Zelda Return of the Hylian
    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <iostream>

#include <SDL/SDL.h>

/*#include "Menu.h"
#include "Texte.h"
#include "Joueur.h"
#include "Monde.h"
#include "Projectile.h"
#include "Jeu.h"*/
#include "Keyboard.h"

Keyboard::Keyboard(Jeu* jeu, Carte* carte, SDL_Surface* screen, int m) : 
    gpJeu(jeu), gpCarte(carte), mode(m), gFullScreen(0), 
    gpScreen(screen), tmp(0), tmpx(0), tmpc(0), tmpw(0), tmpt(0), tmpp(0), tmpm(0),
    ligne(0), colonne(0), ligneOption(2), volume(32), volson(32), ligneRecord(3), 
    colonneRecord(0), temps(0), ligneVal(0), intro(0) {
    for (int i = 0; i < 3; i++) save[i]=0;
    for (int i = 0; i < 3; i++) rang[i]=0;
    loadP();
    gpJeu->getAudio()->setVolume(volume);
    gpJeu->getAudio()->setVolson(volson);
}

void Keyboard::saveP() {
    ofstream f("data/save/system.dat",ios::out | ios::binary);
    f.write((char *)&volume,sizeof(int));
    f.write((char *)&volson,sizeof(int));
    f.write((char *)&temps,sizeof(int));
    for (int i = 0; i < 3; i++) f.write((char *)&rang[i],sizeof(int));
    f.close();
}

void Keyboard::loadP() {
    ifstream f("data/save/system.dat",ios::in | ios::binary);
    if(!f.is_open()) return;
    f.read((char *)&volume,sizeof(int));
    f.read((char *)&volson,sizeof(int));
    f.read((char *)&temps,sizeof(int));
    for (int i = 0; i < 3; i++) f.read((char *)&rang[i],sizeof(int));
    f.close();
}

int Keyboard::getLigne() {return ligne;}
int Keyboard::getColonne() {return colonne;}
int Keyboard::getSave(int i) {return save[i];}
void Keyboard::setSave(int i, int val) {save[i]=val;}
int Keyboard::getLigneOption() {return ligneOption;}
int Keyboard::getVolume() {return volume;}
int Keyboard::getVolson() {return volson;}
int Keyboard::getLigneRecord() {return ligneRecord;}
int Keyboard::getColonneRecord() {return colonneRecord;}
int Keyboard::getTemps() {return temps;}
void Keyboard::setTemps(int t) {temps=t;}
int Keyboard::getRang(int i) {return rang[i];}
void Keyboard::setRang(int i) {rang[i]=1;}
int Keyboard::getLigneVal() {return ligneVal;}
int Keyboard::getIntro() {return intro;}
int Keyboard::getMode() {return mode;}
void Keyboard::setMode(int i) {mode=i;}

int Keyboard::gererClavier() {
    while (SDL_PollEvent(&event)) {
        switch (event.type) {
            case SDL_QUIT : return -1;
            case SDL_KEYDOWN :
                if (pollKey(event) == -1) return -1;
                break;
        }
    }
    keys = SDL_GetKeyState(NULL);
    pollKeys(keys);
    
    return 0;
}

void Keyboard::toggleFullScreen() {
    gFullScreen = (gFullScreen ? 0 : SDL_FULLSCREEN);
    gFullScreen ? SDL_ShowCursor(SDL_DISABLE) : SDL_ShowCursor(SDL_ENABLE);
    gpScreen = SDL_SetVideoMode(640, 480, 32, SDL_HWSURFACE
                                |SDL_DOUBLEBUF|gFullScreen);   
}

int Keyboard::pollKey(SDL_Event event) {
    switch (event.key.keysym.sym) {
        case SDLK_ESCAPE :
            if (mode==0) { if (!gpJeu->getStop() && !gpJeu->getMenu() && !gpJeu->getJoueur()->getImmo() && gpJeu->getJoueur()->getVie()>0) 
                gpJeu->ecrit(215);
            } else if (mode<8 || mode==9 || mode==11 || mode==15 || mode==16 || mode >18) return -1;
            break;
        case SDLK_F1 :
            if (mode == 0) {mode = 17; gpJeu->getGenerique()->initAide1(); 
                gpJeu->getAudio()->playSound(1);}
            break;
        case SDLK_F4 :
            if (event.key.keysym.mod & KMOD_ALT) return -1;
            break;
        case SDLK_RETURN :
            if (event.key.keysym.mod & KMOD_CTRL) toggleFullScreen();
            break;
        case SDLK_SPACE :
            if (mode==11)  return -1;
        default : break;
    }
    return 0;
}

void Keyboard::pollKeys(Uint8* keys) {
    Joueur* gpJoueur;
    int vit;
    int avance;
    int nbdir;
    switch (mode) {
        case 0 :
            gpJoueur = gpJeu->getJoueur();
            
            if (keys[SDLK_RETURN] && tmp == 0) {
                if (gpJoueur->getTypeAnim() == MORT) gpJoueur->revie();
                else if (gpJeu->getText()) gpJeu->setText(gpJeu->getTexte()->suite());
                else if (!gpJeu->getMenu()) gpJeu->setMenu(true);
                else if (gpJeu->getMenu()) gpJeu->setMenu(false);
                tmp = 1;
            }
            if (!keys[SDLK_RETURN] && !gpJeu->getMenu() || gpJeu->getMenu() 
            && !keys[SDLK_RETURN] && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] 
            && !keys[SDLK_UP] && !keys[SDLK_DOWN]) tmp=0;
            
            if (gpJeu->getText() && gpJeu->getTexte()->isFinished()) {
                if(tmpt==0){
                    tmpt=1;
                    switch (gpJeu->getTexte()->getId()) {
                        case 27 : case 106 : case 114 : case 116 : case 118 : case 120 :
                        case 122 : case 124 : case 126 : case 153 : case 161 : case 166 :
                        case 169 : case 172 : case 176 :
                            if (keys[SDLK_LEFT] || keys[SDLK_RIGHT]) {
                                gpJeu->getAudio()->playSound(3);
                                gpJeu->getTexte()->changeId(gpJeu->getTexte()->getId()+1);
                            }
                            break;
                        case 28 : case 107 : case 115 : case 117 : case 119 : case 121 :
                        case 123 : case 125 : case 127 : case 154 : case 162 : case 167 :
                        case 170 : case 173 : case 177 :
                            if (keys[SDLK_LEFT] || keys[SDLK_RIGHT]) {
                                gpJeu->getAudio()->playSound(3);
                                gpJeu->getTexte()->changeId(gpJeu->getTexte()->getId()-1);
                            }
                            break;
                        case 215 : case 216 : case 217 : case 225 : case 226 :
                            if (keys[SDLK_UP] && gpJeu->getTexte()->getId()!=215
                            && gpJeu->getTexte()->getId()!=225) {
                                gpJeu->getAudio()->playSound(3);
                                gpJeu->getTexte()->changeId(gpJeu->getTexte()->getId()-1);
                            }
                            if (keys[SDLK_DOWN] && gpJeu->getTexte()->getId()!=216
                            && gpJeu->getTexte()->getId()!=226) {
                                gpJeu->getAudio()->playSound(3);
                                gpJeu->getTexte()->changeId(gpJeu->getTexte()->getId()+1);
                            }
                            break;
                    }
                }
                if (!keys[SDLK_RETURN] && !keys[SDLK_RETURN] && !keys[SDLK_LEFT] 
                && !keys[SDLK_RIGHT] && !keys[SDLK_UP] && !keys[SDLK_DOWN]) tmpt=0;
            }
            
            
            //curseur menu
            if (gpJeu->getMenu()) {
                if (keys[SDLK_LEFT] && tmp==0 && (gpJoueur->getTypeAnim()<4 || gpJoueur->getTypeAnim()>20) && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) {
                    int obj = gpJoueur->getObjet();
                    if (obj%3 == 0) gpJoueur->setObjet(obj+2);
                    else gpJoueur->setObjet(obj-1);
                    gpJeu->getAudio()->playSound(3);
                    tmp=1;
                }
                if (keys[SDLK_RIGHT] && tmp==0 && (gpJoueur->getTypeAnim()<4 || gpJoueur->getTypeAnim()>20) && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) {
                    int obj = gpJoueur->getObjet();
                    if (obj%3 == 2) gpJoueur->setObjet(obj-2);
                    else gpJoueur->setObjet(obj+1);
                    gpJeu->getAudio()->playSound(3);
                    tmp=1;
                }
                if (keys[SDLK_UP] && tmp==0 && (gpJoueur->getTypeAnim()<4 || gpJoueur->getTypeAnim()>20) && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) {
                    int obj = gpJoueur->getObjet();
                    if (obj/3 == 0) gpJoueur->setObjet(obj+3);
                    else gpJoueur->setObjet(obj-3);
                    gpJeu->getAudio()->playSound(3);
                    tmp=1;
                }
                if (keys[SDLK_DOWN] && tmp==0 && (gpJoueur->getTypeAnim()<4 || gpJoueur->getTypeAnim()>20) && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) {
                    int obj = gpJoueur->getObjet();
                    if (obj/3 == 1) gpJoueur->setObjet(obj-3);
                    else gpJoueur->setObjet(obj+3);
                    gpJeu->getAudio()->playSound(3);
                    tmp=1;
                }
            }
            else // hors menu
            {
                nbdir=0;
                if (keys[SDLK_UP]) nbdir++;
                if (keys[SDLK_DOWN]) nbdir++;
                if (keys[SDLK_LEFT]) nbdir++;
                if (keys[SDLK_RIGHT]) nbdir++;
                
                int vitesse;
                if ((keys[SDLK_CAPSLOCK] || keys[SDLK_LSHIFT])) vitesse=4; 
                else vitesse=2;
        
                avance=0;
                
                //marche
                if (!keys[SDLK_LCTRL] && (
                gpJoueur->getTypeAnim()==AUCUNE || gpJoueur->getTypeAnim()==MARCHE 
                || gpJoueur->getTypeAnim()==PORTE || gpJoueur->getTypeAnim()==EMMENE
                || gpJoueur->getTypeAnim()==NAGE || gpJoueur->getTypeAnim()==FLOTTE) 
                && !gpJeu->getStop() && !gpJeu->getTransition() && !gpJoueur->getImmo()) {
                    gpJoueur->savePrec();
                    if (keys[SDLK_LEFT]) {
                        if(!gpJoueur->getCharge() 
                        && (!keys[SDLK_UP] || gpJoueur->getDirection()!=N) 
                        && (!keys[SDLK_DOWN] || gpJoueur->getDirection()!=S))
                            gpJoueur->setDirection(O);
                        if (gpJoueur->getX()%4==2) vit=2; else vit = vitesse;
                        //gpJeu->moveJoueurX(-vit, nbdir);
                        gpJoueur->moveX(-vit, nbdir);
                        avance = 1;
                    }
                    if (keys[SDLK_RIGHT]) {
                        if(!gpJoueur->getCharge() 
                        && (!keys[SDLK_UP] || gpJoueur->getDirection()!=N) 
                        && (!keys[SDLK_DOWN] || gpJoueur->getDirection()!=S))
                            gpJoueur->setDirection(E);
                        if (gpJoueur->getX()%4==2) vit=2; else vit = vitesse;
                        //gpJeu->moveJoueurX(vit, nbdir);
                        gpJoueur->moveX(vit, nbdir);
                        avance=1;
                    }
                    if (keys[SDLK_UP]) {
                        if(!gpJoueur->getCharge()
                        && (!keys[SDLK_LEFT] || gpJoueur->getDirection()!=O) 
                        && (!keys[SDLK_RIGHT] || gpJoueur->getDirection()!=E))
                            gpJoueur->setDirection(N);
                        if (gpJoueur->getY()%4!=0) vit=2; else vit = vitesse;
                        //gpJeu->moveJoueurY(-vit, nbdir);
                        gpJoueur->moveY(-vit, nbdir);
                        avance=1;
                    }
                    if (keys[SDLK_DOWN]) {
                        if(!gpJoueur->getCharge()
                        && (!keys[SDLK_LEFT] || gpJoueur->getDirection()!=O) 
                        && (!keys[SDLK_RIGHT] || gpJoueur->getDirection()!=E))
                            gpJoueur->setDirection(S);
                        if (gpJoueur->getY()%4!=0) vit=2; else vit = vitesse;
                        //gpJeu->moveJoueurY(vit, nbdir);
                        gpJoueur->moveY(vit, nbdir);
                        avance=1;
                    }
                    if (gpJeu->getVueHorz()>0) {
                        if (gpJeu->getVueHorz()>=4) gpJeu->setVueHorz(gpJeu->getVueHorz()-4);
                        else gpJeu->setVueHorz(0);
                    }
                    if (gpJeu->getVueHorz()<0) {
                        if (gpJeu->getVueHorz()<=-4) gpJeu->setVueHorz(gpJeu->getVueHorz()+4);
                        else gpJeu->setVueHorz(0);
                    }
                    if (gpJeu->getVueVert()>0) {
                        if (gpJeu->getVueVert()>=4) gpJeu->setVueVert(gpJeu->getVueVert()-4);
                        else gpJeu->setVueVert(0);
                    }
                    if (gpJeu->getVueVert()<0) {
                        if (gpJeu->getVueVert()<=-4) gpJeu->setVueVert(gpJeu->getVueVert()+4);
                        else gpJeu->setVueVert(0);
                    }
                }
                if (keys[SDLK_LCTRL] && !gpJoueur->getImmo()) {
                    if (keys[SDLK_LEFT] && gpJeu->getVueHorz()>-64)
                        gpJeu->setVueHorz(gpJeu->getVueHorz()-2);
                    if (keys[SDLK_RIGHT] && gpJeu->getVueHorz()<64)
                        gpJeu->setVueHorz(gpJeu->getVueHorz()+2);
                    if (keys[SDLK_UP] && gpJeu->getVueVert()>-64)
                        gpJeu->setVueVert(gpJeu->getVueVert()-2);
                    if (keys[SDLK_DOWN] && gpJeu->getVueVert()<64)
                        gpJeu->setVueVert(gpJeu->getVueVert()+2);
                }
                
                if (avance == 1) {
                    if (gpJoueur->getTypeAnim()==AUCUNE) gpJoueur->setTypeAnim(MARCHE);
                    if (gpJoueur->getTypeAnim()==FLOTTE) gpJoueur->setTypeAnim(NAGE);
                    if (gpJoueur->getTypeAnim()==PORTE) gpJoueur->setTypeAnim(EMMENE);
                    gpJeu->testFin();
                }
                else {
                    if (gpJoueur->getTypeAnim()==MARCHE && !gpJeu->getStop()) 
                        gpJoueur->setTypeAnim(AUCUNE);
                    if (gpJoueur->getTypeAnim()==NAGE && !gpJeu->getStop()) 
                        gpJoueur->setTypeAnim(FLOTTE);
                    if (gpJoueur->getTypeAnim()==EMMENE && !gpJeu->getStop()) 
                        gpJoueur->setTypeAnim(PORTE);
                }
                
                
                //pe
                if ((gpJoueur->getTypeAnim()==AUCUNE || gpJoueur->getTypeAnim()==MARCHE) 
                && !gpJoueur->getCharge() && gpJoueur->getEpee() && !gpJeu->getStop()
                && !gpJoueur->getImmo()) {
                    if ((keys[SDLK_z] || keys[SDLK_w]) && !tmpw) {
                        gpJoueur->setTypeAnim(EPEE);
                        //gpJoueur->chargeSpin();
                        tmpw=1;
                    }
                    if (!keys[SDLK_z] && !keys[SDLK_w] && tmpw) tmpw=0;
                }
                
                if (keys[SDLK_x] && (
                gpJoueur->getTypeAnim()==AUCUNE || gpJoueur->getTypeAnim()==MARCHE || 
                (gpJoueur->getObjet()==8 && 
                (gpJoueur->getTypeAnim()==PORTE || gpJoueur->getTypeAnim()==EMMENE))) 
                && !gpJeu->getStop() && !gpJoueur->getImmo()
                && gpJoueur->getVie()>0 && !gpJoueur->getCharge() 
                && !tmpx && gpJeu->getZone()!=21  ) {
                    tmpx=1;
                    if(gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7)
                    {
                        switch(gpJoueur->getObjet()) 
                        {
                            case 0 : //arc
                                gpJoueur->setTypeAnim(ARC);
                                break;
                            case 1 : //grappin
                                gpJoueur->setTypeAnim(GRAPPIN);
                                break;
                            case 2 : //bouclier
                                break;
                            case 3 : //baguette de feu
                                gpJoueur->setTypeAnim(BFEU);
                                break;
                            case 4 : //pe
                                break;
                            case 5 : //bouteille
                                 gpJoueur->setTypeAnim(BOIRE);
                                break;
                        } 
                    }   
                    else
                        gpJoueur->setTypeAnim(GRAPPIN);
                                
                }
                
                if (keys[SDLK_s] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7 && tmpx==0) 
                {
                    gpJoueur->setObjet((gpJoueur->getObjet()+5)%6);
                    tmpx=1;
                }
                
                if (keys[SDLK_d] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7 && tmpx==0) 
                {
                    gpJoueur->setObjet((gpJoueur->getObjet()+7)%6);
                    tmpx=1;
                }
                
                if ((!keys[SDLK_x] && !keys[SDLK_s] && !keys[SDLK_d]) && tmpx) tmpx=0;
                                
                
                if (keys[SDLK_1] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(0);
                if (keys[SDLK_2] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(1);
                if (keys[SDLK_3] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(2);
                if (keys[SDLK_4] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(3);
                if (keys[SDLK_5] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(4);
                if (keys[SDLK_6] && gpJeu->getPartie()->getTypeJeu()!=6 && gpJeu->getPartie()->getTypeJeu()!=7) gpJoueur->setObjet(5);
                if (keys[SDLK_7] && gpJoueur->getObjet()==5 && gpJoueur->hasBouteille(0)==1 && gpJoueur->getRubis()>=10)
                {
                    gpJoueur->setBouteille(0,2);
                    if (gpJeu->estServeur()) gpJoueur->setRubis( gpJoueur->getRubis()-10);
                }
                if (keys[SDLK_8] && gpJoueur->getObjet()==5 && gpJoueur->hasBouteille(0)==1 && gpJoueur->getRubis()>=8)
                {
                    gpJoueur->setBouteille(0,3);
                    if (gpJeu->estServeur()) gpJoueur->setRubis( gpJoueur->getRubis()-8);
                }
                if (keys[SDLK_9] && gpJoueur->getObjet()==5 && gpJoueur->hasBouteille(0)==1 && gpJoueur->getRubis()>=15)
                {
                    gpJoueur->setBouteille(0,4);
                    if (gpJeu->estServeur()) gpJoueur->setRubis( gpJoueur->getRubis()-15);
                }
                
                
                if (keys[SDLK_p] && !gpJeu->getStop() && !tmpp) {
                    mode = 12;
                    gpJeu->getAudio()->playSound(1);
                    gpCarte->init();
                    tmpp=1;
                }
                
                if (!keys[SDLK_p] && tmpp) tmpp=0;
                
                if ((keys[SDLK_m] || keys[SDLK_SEMICOLON]) && !tmpm) {
                    gpJeu->getAudio()->playSound(1);
                    gpJeu->getPartie()->setAfficheNom(gpJeu->getPartie()->getAfficheNom()+1);
                    tmpm=1;
                }
                
                if (!(keys[SDLK_m] || keys[SDLK_SEMICOLON]) && tmpm) tmpm=0;
            }
            break;
        case 1 :
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                mode = 2;
                gpJeu->getGenerique()->initLogo();
                gpJeu->getAudio()->playSound(1);
                tmp = 1;
            }
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE])) tmp=0;
            break;
        case 2 :
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                mode = 3;
                gpJeu->getGenerique()->initTitre();
                gpJeu->getAudio()->playSound(1);
                gpJeu->getAudio()->playMusic(45);
                tmp = 1;
            }
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE])) tmp=0;
            break;
        case 3 :
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                mode = 4; colonne=0;
                gpJeu->getGenerique()->initSelection();
                gpJeu->getAudio()->playSound(1);
                gpJeu->getAudio()->playMusic(46);
                tmp = 1;
            }
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE])) tmp=0;
            break;
        case 4 : //Menu de choix
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
            
                if (ligne == 0)
                {
                    mode = 22; ligneVal=0;
                    gpJeu->getGenerique()->EditJoueur();
                }
                if (ligne == 1)
                {
                    mode = 23; ligneVal=0;
                    gpJeu->getGenerique()->LanceServeur();
                    
                }
                if (ligne == 2)
                {
                    mode = 24; ligneOption=0; ligneVal=0;
                    gpJeu->getGenerique()->LanceClient();
                }
                if (ligne == 3) {
                    mode = 6; ligneOption=2;
                    gpJeu->getGenerique()->initOption();
                }
               
                tmp=1; gpJeu->getAudio()->playSound(1);
            }
            
            if (keys[SDLK_UP] && !tmp) {
                ligne--; if (ligne<0) ligne=3; tmp=1; 
                if (ligne!=3) colonne=0;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                ligne++; if (ligne>3) ligne=0; tmp=1;
                if (ligne!=3) colonne=0;
                gpJeu->getAudio()->playSound(3);}
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] && tmp) tmp=0;
            break;
        case 6 : //menu option du son
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0 && ligneOption == 2) {
                mode = 4;
                gpJeu->getGenerique()->initSelection();
                gpJeu->getAudio()->playSound(2);
                tmp = 1;
                saveP();
            }
            
            if (keys[SDLK_UP] && !tmp) {
                ligneOption--; if (ligneOption<0) ligneOption=2; tmp=1; 
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                ligneOption++; if (ligneOption>2) ligneOption=0; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp) {
                if (ligneOption == 0) {
                    volume-=8; if (volume < 0) volume = 0; tmp=1;
                    gpJeu->getAudio()->setVolume(volume); gpJeu->getAudio()->playSound(3);}
                if (ligneOption == 1) {
                    volson-=8; if (volson < 0) volson = 0; tmp=1;
                    gpJeu->getAudio()->setVolson(volson); gpJeu->getAudio()->playSound(3);}}
            if (keys[SDLK_RIGHT] && !tmp) {
                if (ligneOption == 0) {
                    volume+=8; if (volume > 64) volume = 64; tmp=1;
                    gpJeu->getAudio()->setVolume(volume);gpJeu->getAudio()->playSound(3);}
                if (ligneOption == 1) {
                    volson+=8; if (volson > 64) volson = 64; tmp=1;
                    gpJeu->getAudio()->setVolson(volson);gpJeu->getAudio()->playSound(3);}}
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] 
                && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] && tmp) tmp=0;
            break;
        case 7 : 
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                if (ligneVal==0) {
                    mode = 0;
                    gpJeu->init(ligne);
                }
                if (ligneVal==1) {
                    mode = 9; ligneVal=1;
                    gpJeu->getGenerique()->initEffacer();
                    gpJeu->getAudio()->playSound(1);
                }
                if (ligneVal==2) {
                    mode = 4; gpJeu->getGenerique()->initSelection();
                    gpJeu->getAudio()->playSound(2);
                }    
                tmp = 1;
            }
            
            if (keys[SDLK_UP] && !tmp) {
                if (--ligneVal<0) ligneVal=2; tmp=1; 
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                if (++ligneVal>2) ligneVal=0; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] && tmp) tmp=0;
            break;
        case 8 :
            //pas utiliser
        case 9 :
            // pas utiliser
        case 10 ://????????????,
            if (keys[SDLK_RETURN] && tmp == 0) {
                if (gpJeu->getText()) gpJeu->setText(gpJeu->getTexte()->suite());
                if (!gpJeu->getText()) {
                    mode = 0; //gpJeu->init(ligne+1);
                    gpJeu->ecrit(236);
                }
                tmp = 1;
            }
            if (!keys[SDLK_RETURN] && tmp) tmp=0;
            break;
        case 11 ://ecran de fin
            /*if (keys[SDLK_SPACE] && !tmp) {
                mode=4; colonne=0; ligne=0;
                
                gpJeu->retourMenu();
                
                //gpJeu->getGenerique()->initSelection();
                gpJeu->getAudio()->playSound(2);
                
                tmp=1;
            }
            if (!keys[SDLK_SPACE]) tmp=0;*/
            break;
        case 12 :
            if (keys[SDLK_RETURN] && !tmp) {
                mode = 0;
                gpJeu->getAudio()->playSound(2);
                tmp=1;
            }
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_UP] && !keys[SDLK_DOWN] && tmp) tmp=0;
            break;
        case 13 :
            /*if (keys[SDLK_RETURN] && !tmp) {
                mode = 0;
                gpJeu->getAudio()->playSound(2);
                tmp=1;
            }
            
            if (keys[SDLK_LEFT] && !tmp) {
                gpJeu->getAudio()->playSound(3);
                gpEncyclopedie->moveL();
                tmp=1;
            }
            if (keys[SDLK_RIGHT] && !tmp) {
                gpJeu->getAudio()->playSound(3);
                gpEncyclopedie->moveR();
                tmp=1;
            }
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] && tmp) tmp=0;*/
            break;
        case 14 :
            if (keys[SDLK_RETURN] && tmp == 0) {
                mode = 2; gpJeu->getAudio()->playSound(1);
                gpJeu->getGenerique()->initLogo();
                tmp = 1;
            }
            if (!keys[SDLK_RETURN] && tmp) tmp=0;
            break;
        case 15 ://vide
        case 16 :
            if (keys[SDLK_RETURN] && tmp == 0) {
                mode = 15;
                if (ligneVal==0) {
                    gpJeu->getAudio()->playSound(2);
                    temps=0; for (int i = 0; i < 3; i++) rang[i]=0; saveP();
                }
                else gpJeu->getAudio()->playSound(1);
                gpJeu->getGenerique()->initRecord();
                tmp = 1;
            }
            
            if ((keys[SDLK_UP] || keys[SDLK_DOWN]) && !tmp) {
                ligneVal ? ligneVal=0 : ligneVal = 1; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_UP] && !keys[SDLK_DOWN] && tmp) tmp=0;
            break;
        case 17 ://aide 1
            if (keys[SDLK_RETURN] && !tmp) {
                mode = 0;
                gpJeu->getAudio()->playSound(2);
                tmp=1;
            }
            if (keys[SDLK_RIGHT] && !tmp) {
                mode = 18; gpJeu->getGenerique()->initAide2();
                gpJeu->getAudio()->playSound(3); tmp=1;}
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_RIGHT] && tmp) tmp=0;
            break;
        case 18 ://aide 2
            if (keys[SDLK_RETURN] && !tmp) {
                mode = 0;
                gpJeu->getAudio()->playSound(2);
                tmp=1;
            }
            if (keys[SDLK_LEFT] && !tmp) {
                mode = 17; gpJeu->getGenerique()->initAide1();
                gpJeu->getAudio()->playSound(3); tmp=1;}
                
            if (keys[SDLK_RIGHT] && !tmp) {
                mode = 19; gpJeu->getGenerique()->initAide3();
                gpJeu->getAudio()->playSound(3); tmp=1;}
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_LEFT] && tmp && !keys[SDLK_RIGHT]) tmp=0;
            break;
        case 19 : // aide 3
            if (keys[SDLK_RETURN] && !tmp) {
                mode = 0;
                gpJeu->getAudio()->playSound(2);
                tmp=1;
            }
            if (keys[SDLK_LEFT] && !tmp) {
                mode = 18; gpJeu->getGenerique()->initAide2();
                gpJeu->getAudio()->playSound(3); tmp=1;}
            
            if (!keys[SDLK_RETURN] && !keys[SDLK_LEFT] && tmp) tmp=0;
            break;
        case 20 :// probleme serveur
            if (keys[SDLK_RETURN] && tmp == 0) {
               tmp = 1;
               mode = 4; colonne=0;
               gpJeu->getGenerique()->initSelection();
               gpJeu->getAudio()->playSound(1);
                    
            }
            if (!keys[SDLK_RETURN] && tmp) tmp=0;
            break;    
        case 21 :// procbleme client
            if (keys[SDLK_RETURN] && tmp == 0) {
               tmp = 1;
               mode = 4; colonne=0;
               gpJeu->getGenerique()->initSelection();
               gpJeu->getAudio()->playSound(1);
               
            }
            if (!keys[SDLK_RETURN] && tmp) tmp=0;
            break;
        case 22 : // Edit joueur
            if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                
                if (ligneVal == 2)
                 {
                    mode = 4; colonne=0;
                    gpJeu->getGenerique()->initSelection();
                    gpJeu->getAudio()->playSound(1);
                    tmp = 1;
                }
            }
            
            if (keys[SDLK_UP] && !tmp) {
                ligneVal--; if (ligneVal<0) ligneVal=2; tmp=1; 
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                ligneVal++; if (ligneVal>2) ligneVal=0; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp && ligneVal==0) {
                gpJeu->getJoueur()->setCouleur(gpJeu->getJoueur()->getCouleur()-1);
                gpJeu->getGenerique()-> EditJoueur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_RIGHT] && !tmp && ligneVal==0) {
                gpJeu->getJoueur()->setCouleur(gpJeu->getJoueur()->getCouleur()+1);
                gpJeu->getGenerique()-> EditJoueur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp && ligneVal==1) {
                gpJeu->getJoueur()->setNom(gpJeu->getJoueur()->getNom()-1);
                gpJeu->getGenerique()-> EditJoueur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_RIGHT] && !tmp && ligneVal==1) {
                gpJeu->getJoueur()->setNom(gpJeu->getJoueur()->getNom()+1);
                gpJeu->getGenerique()-> EditJoueur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] 
                && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] && tmp) tmp=0;
            break;
        case 23 : // lance serveur
          if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                
                if (ligneVal == 3)
                 {
                    gpJeu->getAudio()->playSound(1);
                    tmp = 1;
                    if(gpJeu->init(1))
                        mode = 0;
                    else
                        mode = 20;
                    
                }
                 if (ligneVal == 4)
                 {
                    mode = 4; colonne=0;
                    gpJeu->getGenerique()->initSelection();
                    gpJeu->getAudio()->playSound(1);
                    tmp = 1;
                }
            }
            
            if (keys[SDLK_UP] && !tmp) {
                ligneVal--; if (ligneVal<0) ligneVal=4; tmp=1; 
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                ligneVal++; if (ligneVal>4) ligneVal=0; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp && ligneVal==0) {
                gpJeu->getPartie()->setTypeJeu(gpJeu->getPartie()->getTypeJeu()-1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_RIGHT] && !tmp && ligneVal==0) {
                gpJeu->getPartie()->setTypeJeu(gpJeu->getPartie()->getTypeJeu()+1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp && ligneVal==1) {
                gpJeu->getPartie()->setArene(gpJeu->getPartie()->getArene()-1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_RIGHT] && !tmp && ligneVal==1) {
                gpJeu->getPartie()->setArene(gpJeu->getPartie()->getArene()+1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] && !tmp && ligneVal==2) {
                gpJeu->getPartie()->setLimite(gpJeu->getPartie()->getLimite()-1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_RIGHT] && !tmp && ligneVal==2) {
                gpJeu->getPartie()->setLimite(gpJeu->getPartie()->getLimite()+1);
                gpJeu->getGenerique()-> LanceServeur();
                tmp=1;
                gpJeu->getAudio()->playSound(3);}
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] 
                && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] && tmp) tmp=0;
            break;
          case 24 : // lance client
          if ((keys[SDLK_RETURN] || keys[SDLK_SPACE]) && tmp == 0) {
                
                if (ligneVal == 4)
                 {
                    gpJeu->getAudio()->playSound(1);
                    tmp = 1;
                    if(gpJeu->init(2))
                        mode = 0;
                    else
                        mode = 21;
                        
                }
                if (ligneVal == 5)
                {
                    mode = 4; colonne=0;
                    gpJeu->getGenerique()->initSelection();
                    gpJeu->getAudio()->playSound(1);
                    tmp = 1;
                }
            }
            
            if (keys[SDLK_UP] && !tmp) {
                ligneVal--; if (ligneVal<0) ligneVal=5; tmp=1; 
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_DOWN] && !tmp) {
                ligneVal++; if (ligneVal>5) ligneVal=0; tmp=1;
                gpJeu->getAudio()->playSound(3);}
            if (keys[SDLK_LEFT] /*&& !tmp*/ && ligneVal<4) {
                if ((tmp%5==0 && tmp<=40) || (tmp%2==0 && tmp>40))
                {
                  gpJeu->setIP(-1,ligneVal);
                  gpJeu->getGenerique()-> LanceClient();
                }
                if (tmp<50) tmp++;
                }
            if (keys[SDLK_RIGHT] /*&& !tmp*/ && ligneVal<4) {
                if ((tmp%5==0 && tmp<=40) || (tmp%2==0 && tmp>40))
                {
                  gpJeu->setIP(1,ligneVal);
                  gpJeu->getGenerique()-> LanceClient();
                }
                if (tmp<50) tmp++;
                }
            
            if (!(keys[SDLK_RETURN] || keys[SDLK_SPACE]) && !keys[SDLK_UP] && !keys[SDLK_DOWN] 
                && !keys[SDLK_LEFT] && !keys[SDLK_RIGHT] && tmp!=0) tmp=0;
            break;
    }
}


