/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/


#include "Serveur.h"
#include "Projectile.h"
#include "Statut.h"
#include "Joueur.h"
#include "Monde.h"
#include "Menu.h"
#include "Texte.h"
#include "Jeu.h"

Partie::Partie(Jeu* jeu)
{
    NbJoueur = 10;
    NbTypeJeu = 8;
    NbLimite = 5;
    NbArene = 18;
    NbEquipe = 10;
    
    TypeJeu = 0;
    Limite = 0;
    Arene=0;
    
    AfficheNom=2;
    
    gpJeu = jeu;
    jeuFini = 0;
}

Partie::~Partie()
{
}

void Partie::init(int Type, int Lieu)
{
     TypeJeu = Type;
     Arene = Lieu;
}


int Partie::getTypeJeu() {
    return TypeJeu;
}

string Partie::getTypeJeuName() {
    string im;
    switch(TypeJeu) {
      case 0 : im = "Chacun pour soi"; break;
      case 1 : im = "Par equipe"; break;
      case 2 : im = "Vol de rubis"; break;
      case 3 : im = "PRV"; break;
      case 4 : im = "Bonus Couleur"; break;
      case 5 : im = "Le Fantome"; break;
      case 6 : im = "Only Sword"; break;
      case 7 : im = "Team Only Sword"; break;
      }
    
    return im;
}

void Partie::setTypeJeu(int a) {
    TypeJeu = a;
    if (TypeJeu < 0) TypeJeu = NbTypeJeu-1;
    TypeJeu = (TypeJeu%NbTypeJeu);
}

int Partie::getLimite() {
    return Limite;
}

int Partie::getLimiteVal() {
    int val;
    switch(Limite) {
      case 0 : val = 5; break;
      case 1 : val = 10; break;
      case 2 : val = 20; break;
      case 3 : val = 40; break;
      case 4 : val = 99; break;
      }
    
    return val;
}

string Partie::getLimiteName() {
    string im;
    switch(Limite) {
      case 0 : im = "Score- 5 pts"; break;
      case 1 : im = "Score- 10 pts"; break;
      case 2 : im = "Score- 20 pts"; break;
      case 3 : im = "Score- 40 pts"; break;
      case 4 : im = "Score- 99 pts"; break;
      }
    
    return im;
}

void Partie::setLimite(int a) {
    Limite = a;
    if (Limite < 0) Limite = NbLimite-1;
    Limite = (Limite%NbLimite);
}

int Partie::getArene() {
    return Arene;
}

//salle debut jeu = 21
int Partie::getAreneToZone() {
   
   if (Arene==NbArene-1)
      Arene = ((int)rand())%NbArene-1;
  
    int im;
    switch(Arene) {
      case 0 : im = 9; break;
      case 1 : im = 8; break;
      case 2 : im = 12; break;
      case 3 : im = 3; break;
      case 4 : im = 1; break;
      case 5 : im = 5; break;
      case 6 : im = 32; break;
      case 7 : im = 38; break;
      case 8 : im = 2; break;
      case 9 : im = 13; break;
      case 10 : im = 27; break;
      case 11 : im = 6; break;
      case 12 : im = 30; break;
      case 13 : im = 7; break;
      case 14 : im = 4; break;
      case 15 : im = 10; break;
      case 16 : im = 11; break;
    }
    return im;
}

string Partie::getAreneName() {
    string im;
    switch(Arene) {
      case 0 : im = "Le chateau"; break;
      case 1 : im = "Le village"; break;
      case 2 : im = "Le donjon"; break;
      case 3 : im = "Les iles"; break;
      case 4 : im = "Le chateau 2"; break;
      case 5 : im = "Le desert"; break;
      case 6 : im = "La maison"; break;
      case 7 : im = "La forge"; break;
      case 8 : im = "Le palais"; break;
      case 9 : im = "Le donjon 2"; break;
      case 10 : im = "La patinoire"; break;
      case 11 : im = "Le cimetiere"; break;
      case 12 : im = "Le bar"; break;
      case 13 : im = "La plaine"; break;
      case 14 : im = "La montagne"; break;
      case 15 : im = "La tortue"; break;
      case 16 : im = "Chateau Majora"; break;
      case 17 : im = "Aleatoire"; break;
    }
    
    return im;
}
        
void Partie::setArene(int a) {
    Arene = a;
    if (Arene < 0) Arene = NbArene-1;
    Arene = ((Arene)%NbArene);
}

int Partie::getAfficheNom(){ return AfficheNom; }
void Partie::setAfficheNom(int a)
{
    AfficheNom = a%3; 
}

void Partie::positionRevie(int & posX, int & posY)
{
     int depart = 0;
      switch (Arene)
      {
      case 0 : depart = (((int)rand())%7); 
               if (depart == 0) { posX = 310; posY = 150; }
               if (depart == 1) { posX = 450; posY = 600; }
               if (depart == 2) { posX = 100; posY = 850; }
               if (depart == 3) { posX = 1040; posY = 700; }
               if (depart == 4) { posX = 1040; posY = 300; }
               if (depart == 5) { posX = 670; posY = 440; }
               if (depart == 6) { posX = 1470; posY = 840; }
               break;         
      case 1 : depart = (((int)rand())%5); 
               if (depart == 0) { posX = 780; posY = 640; }
               if (depart == 1) { posX = 30; posY = 30; }
               if (depart == 2) { posX = 470; posY = 280; }
               if (depart == 3) { posX = 880; posY = 400; }
               if (depart == 4) { posX = 100; posY = 850; }
               break; 
      case 2 : depart = (((int)rand())%8); 
               if (depart == 0) { posX = 800; posY = 50; }
               if (depart == 1) { posX = 470; posY = 580; }
               if (depart == 2) { posX = 150; posY = 900; }
               if (depart == 3) { posX = 50; posY = 50; }
               if (depart == 4) { posX = 900; posY = 500; }
               if (depart == 5) { posX = 200; posY = 800; }
               if (depart == 6) { posX = 630; posY = 1000; }
               if (depart == 7) { posX = 800; posY = 800; }
               break;
      case 3 : depart = (((int)rand())%7); 
               if (depart == 0) { posX = 200; posY = 80; }
               if (depart == 1) { posX = 450; posY = 300; }
               if (depart == 2) { posX = 350; posY = 700; }
               if (depart == 3) { posX = 990; posY = 740; }
               if (depart == 4) { posX = 1380; posY = 670; }
               if (depart == 5) { posX = 1000; posY = 480; }
               if (depart == 6) { posX = 750; posY = 320; }
               break;
      case 4 : depart = (((int)rand())%6); 
               if (depart == 0) { posX = 860; posY = 860; }
               if (depart == 1) { posX = 100; posY = 880; }
               if (depart == 2) { posX = 150; posY = 150; }
               if (depart == 3) { posX = 500; posY = 100; }
               if (depart == 4) { posX = 820; posY = 100; }
               if (depart == 5) { posX = 500; posY = 570; }
               break;
      case 5 : depart = (((int)rand())%7); 
               if (depart == 0) { posX = 1800; posY = 340; }
               if (depart == 1) { posX = 124; posY = 124; }
               if (depart == 2) { posX = 330; posY = 450; }
               if (depart == 3) { posX = 820; posY = 560; }
               if (depart == 4) { posX = 1000; posY = 130; }
               if (depart == 5) { posX = 1500; posY = 250; }
               if (depart == 6) { posX = 2110; posY = 600; }
               break;
      case 6 : depart = (((int)rand())%6); 
               if (depart == 0) { posX = 50; posY = 50; }
               if (depart == 1) { posX = 770; posY = 110; }
               if (depart == 2) { posX = 300; posY = 290; }
               if (depart == 3) { posX = 570; posY = 470; }
               if (depart == 4) { posX = 970; posY = 170; }
               if (depart == 5) { posX = 970; posY = 570; }
               break;
      case 7 : depart = (((int)rand())%5); 
               if (depart == 0) { posX = 160; posY = 170; }
               if (depart == 1) { posX = 260; posY = 80; }
               if (depart == 2) { posX = 54; posY = 176; }
               if (depart == 3) { posX = 70; posY = 66; }
               if (depart == 4) { posX = 170; posY = 44; }
               break;
      case 8 : depart = (((int)rand())%10); 
               if (depart == 0) { posX = 150; posY = 150; }
               if (depart == 1) { posX = 110; posY = 1100; }
               if (depart == 2) { posX = 100; posY = 1530; }
               if (depart == 3) { posX = 500; posY = 1550; }
               if (depart == 4) { posX = 130; posY = 2290; }
               if (depart == 5) { posX = 800; posY = 2290; }
               if (depart == 6) { posX = 1200; posY = 2100; }
               if (depart == 7) { posX = 1200; posY = 1300; }
               if (depart == 8) { posX = 700; posY = 130; }
               if (depart == 9) { posX = 480; posY = 80; }
               break;
      case 9 : depart = (((int)rand())%5); 
               if (depart == 0) { posX = 530; posY = 630; }
               if (depart == 1) { posX = 560; posY = 300; }
               if (depart == 2) { posX = 220; posY = 380; }
               if (depart == 3) { posX = 90; posY = 320; }
               if (depart == 4) { posX = 470; posY = 100; }
               break;
      case 10 : depart = (((int)rand())%3); 
               if (depart == 0) { posX = 80; posY = 50; }
               if (depart == 1) { posX = 200; posY = 50; }
               if (depart == 2) { posX = 150; posY = 150; }
               break;   
      case 11 : depart = (((int)rand())%6); 
               if (depart == 0) { posX = 100; posY = 100; }
               if (depart == 1) { posX = 450; posY = 300; }
               if (depart == 2) { posX = 50; posY = 660; }
               if (depart == 3) { posX = 300; posY = 1300; }
               if (depart == 4) { posX = 700; posY = 850; }
               if (depart == 5) { posX = 880; posY = 200; }
               break;   
      case 12 : depart = (((int)rand())%4); 
               if (depart == 0) { posX = 160; posY = 50; }
               if (depart == 1) { posX = 50; posY = 150; }
               if (depart == 2) { posX = 250; posY = 250; }
               if (depart == 3) { posX = 60; posY = 400; }
               break;   
      case 13 : depart = (((int)rand())%6);; 
               if (depart == 0) { posX = 200; posY = 260; }
               if (depart == 1) { posX = 1000; posY = 200; }
               if (depart == 2) { posX = 1400; posY = 550; }
               if (depart == 3) { posX = 1420; posY = 880; }
               if (depart == 4) { posX = 500; posY = 800; }
               if (depart == 5) { posX = 1000; posY = 600; }
               break;   
      case 14 : depart = (((int)rand())%8);; 
               if (depart == 0) { posX = 100; posY = 100; }
               if (depart == 1) { posX = 500; posY = 100; }
               if (depart == 2) { posX = 400; posY = 300; }
               if (depart == 3) { posX = 492; posY = 620; }
               if (depart == 4) { posX = 40; posY = 610; }
               if (depart == 5) { posX = 1400; posY = 500; }
               if (depart == 6) { posX = 1700; posY = 400; }
               if (depart == 7) { posX = 1780; posY = 60; }
               break;    
      case 15 : depart = (((int)rand())%7);; 
               if (depart == 0) { posX = 100; posY = 100; }
               if (depart == 1) { posX = 700; posY = 100; }
               if (depart == 2) { posX = 200; posY = 200; }
               if (depart == 3) { posX = 400; posY = 200; }
               if (depart == 4) { posX = 700; posY = 700; }
               if (depart == 5) { posX = 1500; posY = 830; }
               if (depart == 6) { posX = 1600; posY = 200; }
               break;    
      case 16 : depart = (((int)rand())%7);; 
               if (depart == 0) { posX = 250; posY = 350; }
               if (depart == 1) { posX = 70; posY = 50; }
               if (depart == 2) { posX = 290; posY = 660; }
               if (depart == 3) { posX = 900; posY = 600; }
               if (depart == 4) { posX = 640; posY = 240; }
               if (depart == 5) { posX = 1200; posY = 170; }
               if (depart == 6) { posX = 1200; posY = 1000; }
               break;   
      }            
}

/*TypeContact :
    -  0  epee 
    -  1  fleche
    -  2  flche argent
    -  4  bombe
    -  5  feu
    -  6  glace
    
*/
void Partie::Contact(int JoueurAttaque, int JoueurCible, int TypeContact)
{
    bool avantClassement, apresClassement;
    int leScore;    

    switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
          {
              gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
              
              //si on tappe le serveur
              if(JoueurCible==0)
                  gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
              
              //marque le point
              if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
              {
                  leScore = scoreMaxSauf(JoueurAttaque);
                  avantClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() <= leScore);
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                  
                  gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);
                  
                  gpJeu->setMessage(3,JoueurAttaque,JoueurCible);
                  
                  apresClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() > leScore);
                  if(avantClassement && apresClassement) gpJeu->setMessage(8,JoueurAttaque,JoueurCible);
              }
          
          }
      break;
      case 1 : //PAR EQUIPE 
          {
              if(gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur() != gpJeu->getAutreJoueur(JoueurCible)->getCouleur())
              {
                  gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
                  //si on tappe le serveur
                  if(JoueurCible==0)
                      gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
                  
                  //marque le point
                  if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
                  {
                      gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                  
                      gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);       
                      gpJeu->setMessage(3,JoueurAttaque,JoueurCible); 
                  }
              }
          }    
      break;
      case 2 : //VOLE DE RUBIS 
          {
               gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
              
              //si on tappe le serveur
              if(JoueurCible==0)
                  gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
              
              //marque le point
              if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
              {
                  leScore = scoreMaxSauf(JoueurAttaque);
                  avantClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() <= leScore);
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+(gpJeu->getAutreJoueur(JoueurCible)->getRubis()/2));       
                  gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()-(gpJeu->getAutreJoueur(JoueurCible)->getRubis()/2));
                  gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+2);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis());
                  
                  gpJeu->getAutreJoueur(JoueurCible)->setScore(gpJeu->getAutreJoueur(JoueurCible)->getRubis()); 
                  gpJeu->setMessage(4,JoueurAttaque,JoueurCible); 
                  
                  apresClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() > leScore);
                  if(avantClassement && apresClassement) gpJeu->setMessage(8,JoueurAttaque,JoueurCible);
              }
          }     
      break;   
      case 3 : //PRV 
          {
              if((gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==1 && gpJeu->getAutreJoueur(JoueurCible)->getCouleur()==3)
              || (gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==3 && gpJeu->getAutreJoueur(JoueurCible)->getCouleur()==8)
              || (gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==8 && gpJeu->getAutreJoueur(JoueurCible)->getCouleur()==1))
              {
                 gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-2);
                  
                  //si on tappe le serveur
                  if(JoueurCible==0)
                      gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
                  
                  //marque le point
                  if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
                  {
                      gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                      
                      gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);
                      gpJeu->setMessage(3,JoueurAttaque,JoueurCible);       
                  }
              }
          }    
      break;
       case 4 : //Bonus couleur 
          {
              if(TypeContact==0)
              {
                  if (gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque() >= gpJeu->getAutreJoueur(JoueurCible)->getDefense())                                                     
                     gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
                  else
                     gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-1);
                  
              }
              else
                  gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-2);
                  
              //si on tappe le serveur
              if(JoueurCible==0)
                  gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
              
              
              //si on est bordeaux, on copie les stats
              if(gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==7)
              {
                 gpJeu->getAutreJoueur(JoueurAttaque)->setAttaque(gpJeu->getAutreJoueur(JoueurCible)->getAttaque());
                 gpJeu->getAutreJoueur(JoueurAttaque)->setDefense(gpJeu->getAutreJoueur(JoueurCible)->getDefense());
              }
              
              //marque le point
              if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
              {
                  leScore = scoreMaxSauf(JoueurAttaque);
                  avantClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() <= leScore);
                  
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                  if(gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==0) gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()%2));
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                  if(gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur()==6) gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+20);
                  if(gpJeu->getAutreJoueur(JoueurCible)->getCouleur()==6) gpJeu->getAutreJoueur(JoueurCible)->setFleche(gpJeu->getAutreJoueur(JoueurCible)->getFleche()+20);
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
              
                  gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2); 
                  gpJeu->setMessage(3,JoueurAttaque,JoueurCible); 
                  
                  apresClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() > leScore);
                  if(avantClassement && apresClassement) gpJeu->setMessage(8,JoueurAttaque,JoueurCible);
                  
              }
          
          }
      break;
      case 5 : //le fantome 
          {
              gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
              
              //si on tappe le serveur
              if(JoueurCible==0)
                  gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
              
              //marque le point
              if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
              {
                  leScore = scoreMaxSauf(JoueurAttaque);
                  avantClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() <= leScore);
                  gpJeu->setMessage(3,JoueurAttaque,JoueurCible); 
                  
                  if(gpJeu->getAutreJoueur(JoueurAttaque)->isFantome()) gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                  if(gpJeu->getAutreJoueur(JoueurCible)->isFantome())
                  {
                          gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+2);
                          gpJeu->getAutreJoueur(JoueurAttaque)->setFantome(1);
                          gpJeu->setMessage(5,JoueurAttaque);  
                          gpJeu->getAutreJoueur(JoueurCible)->setFantome(0);
                  }
                  
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                  
                  gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);
                  
                  apresClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() > leScore);
                  if(avantClassement && apresClassement) gpJeu->setMessage(8,JoueurAttaque,JoueurCible);
                            
              }
          
          }
      break;
      case 6 : //ONLY SWORD
          {
              gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
              
              //si on tappe le serveur
              if(JoueurCible==0)
                  gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
              
              //marque le point
              if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
              {
                  leScore = scoreMaxSauf(JoueurAttaque);
                  avantClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() <= leScore);
                  
                  gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                  gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                  
                  gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);
                  
                  gpJeu->setMessage(3,JoueurAttaque,JoueurCible);
                  
                  apresClassement = (gpJeu->getAutreJoueur(JoueurAttaque)->getScore() > leScore);
                  if(avantClassement && apresClassement) gpJeu->setMessage(8,JoueurAttaque,JoueurCible);
              }
          
          }
      break;
      case 7 : //TEAM ONLY SWORD
          {
              if(gpJeu->getAutreJoueur(JoueurAttaque)->getCouleur() != gpJeu->getAutreJoueur(JoueurCible)->getCouleur())
              {
                  gpJeu->getAutreJoueur(JoueurCible)->setVie(gpJeu->getAutreJoueur(JoueurCible)->getVie()-gpJeu->getAutreJoueur(JoueurAttaque)->getAttaque()+gpJeu->getAutreJoueur(JoueurCible)->getDefense());
                  //si on tappe le serveur
                  if(JoueurCible==0)
                      gpJeu->getAutreJoueur(JoueurCible)->setTypeAnim(TOUCHE);
                  
                  //marque le point
                  if(gpJeu->getAutreJoueur(JoueurCible)->getVie()<=0)
                  {
                      gpJeu->getAutreJoueur(JoueurAttaque)->setScore(gpJeu->getAutreJoueur(JoueurAttaque)->getScore()+1);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setFleche(gpJeu->getAutreJoueur(JoueurAttaque)->getFleche()+10);
                      gpJeu->getAutreJoueur(JoueurAttaque)->setRubis(gpJeu->getAutreJoueur(JoueurAttaque)->getRubis()+5);
                  
                      gpJeu->getAutreJoueur(JoueurCible)->setRubis(gpJeu->getAutreJoueur(JoueurCible)->getRubis()+2);       
                      gpJeu->setMessage(3,JoueurAttaque,JoueurCible); 
                  }
              }
          }    
      break;

      }
      FinPartie();
}

 void Partie::ModifierJoueur(int JoueurModif)
 {
    //si couleur alatoire
    if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur() == NbEquipe-1)
    {
         gpJeu->getAutreJoueur(JoueurModif)->setCouleur(((int)rand())%(NbEquipe-2));
    } 
    
    switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
          }
          break;
      case 1 : //PAR EQUIPE 
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
          }
          break;
      case 2 : //VOLE DE RUBIS 
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
              gpJeu->getAutreJoueur(JoueurModif)->setScore(10);
          }
          break;
      case 3 : //PRV
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(2);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(2);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur() <= 2) gpJeu->getAutreJoueur(JoueurModif)->setCouleur(1);
              else if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur() <= 5) gpJeu->getAutreJoueur(JoueurModif)->setCouleur(3);
                   else gpJeu->getAutreJoueur(JoueurModif)->setCouleur(8);
          }
          break;
      case 4 : //BonusCouleur 
          {
               /*case 0 : im = "Lapin"; break;
                  case 1 : im = "Vert"; break;
                  case 2 : im = "Rouge"; break;
                  case 3 : im = "Noir"; break;
                  case 4 : im = "Jaune"; break;
                  case 5 : im = "Blanc"; break;
                  case 6 : im = "Bleu"; break;
                  case 7 : im = "Bordeaux"; break; 
                  case 8 : im = "Rose"; break; */
                  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==0)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(3);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(30);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(30);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(32);
              }
              //vert  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==1)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(5);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(1);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(32); 
              }
              //rouge
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==2)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(12);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(12);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(3);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(2);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(30);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(30);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(64);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(64); 
              }
              //noir  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==3)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(4);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(4);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(0); 
              }
              //jaune 
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==4)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(2);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(4);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(2);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(30);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(64);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(10); 
              }
              //blanc
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==5)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(5);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(1);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(0); 
              }
              //bleu  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==6)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(6);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(6);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(99);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(99);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(64);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(64); 
              }
              //bordeaux  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==7)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(10);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(1);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(10); 
              }
              //rose  
              if(gpJeu->getAutreJoueur(JoueurModif)->getCouleur()==8)
              {
                 gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
                 gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
                 gpJeu->getAutreJoueur(JoueurModif)->setRubis(0);
                 gpJeu->getAutreJoueur(JoueurModif)->setAttaque(4);
                 gpJeu->getAutreJoueur(JoueurModif)->setDefense(3);
                 gpJeu->getAutreJoueur(JoueurModif)->setFlecheMax(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setFleche(20);
                 gpJeu->getAutreJoueur(JoueurModif)->setMagieMax(32);   
                 gpJeu->getAutreJoueur(JoueurModif)->setMagie(32); 
              }
              
          }
          break;
      case 5 : //le fantome
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
              if(JoueurModif==0) gpJeu->getAutreJoueur(JoueurModif)->setFantome(1);
          }
          break;
     case 6 : //ONLY SWORD
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
          }
          break;
      case 7 : //TEAM ONLY SWORD 
          {
              gpJeu->getAutreJoueur(JoueurModif)->setVie(8);
              gpJeu->getAutreJoueur(JoueurModif)->setVieMax(8);
              gpJeu->getAutreJoueur(JoueurModif)->setRubis(10);
          }
          break;
      
     }
}

void Partie::AfficheClassement(SDL_Surface* gpScreen,int val)
{
    int i;
    int pos;
    int tmpScore;
    int dec = 200-val;
    gpJeu->affiche(gpScreen, "CLASSEMENT :", 148,20-dec);
    
    
     switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
      case 2 : //VOL DE RUBIS
      case 4 : //Bonus Couleur
      case 5 : //le fantome
      case 6 : //Only sword
          {
                int ordreJoueur[gpJeu->getPartie()->getNbJoueur()] ;
                int ScoreJoueur[gpJeu->getPartie()->getNbJoueur()] ;
                int tailleTab=0;
                for (i=0;i <gpJeu->getPartie()->getNbJoueur(); i++)
                {
                   if(!gpJeu->getAutreJoueur(i)->estInvisible())
                   {
                     ordreJoueur[tailleTab]=i;
                     ScoreJoueur[tailleTab]=gpJeu->getAutreJoueur(i)->getScore(); 
                     tailleTab++;
                   }
                }
                
               
                gpJeu->fct.tri_rapide2T(ScoreJoueur, ordreJoueur, tailleTab);
                pos = 36;
                for(i=0 ; i<tailleTab ; i++)
                {
                   tmpScore = gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getScore();
                   gpJeu->affiche(gpScreen, gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getNomComplet(), 148,pos-dec+8);
                   
                   if (tmpScore >= 0 && tmpScore < 10)
                       gpJeu->affiche(gpScreen, gpJeu->fct.int2string(gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getScore()), 284,pos-dec+8);
                   
                   if (tmpScore >= 10 && tmpScore < 100)
                       gpJeu->affiche(gpScreen, gpJeu->fct.int2string(gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getScore()), 278,pos-dec+8);
                      
                   if (tmpScore >= 100 && tmpScore < 1000)
                       gpJeu->affiche(gpScreen, gpJeu->fct.int2string(gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getScore()), 272,pos-dec+8);
                   
                   if (tmpScore < 0 || tmpScore >= 1000)
                       gpJeu->affiche(gpScreen, gpJeu->fct.int2string(gpJeu->getAutreJoueur(ordreJoueur[tailleTab-i-1])->getScore()), 266,pos-dec+8);

                  pos+=16;
                }
          }
      break; 
      case 1 : //EQUIPE
      case 3 : //PRV
      case 7 : //Team only sword
          {
                //calcul nombre de joueur par equipe
                string NomEquipe[NbEquipe];
                NomEquipe[0] = "Lapin";
                NomEquipe[1] = "Vert"; 
                NomEquipe[2] = "Rouge";
                NomEquipe[3] = "Noir";
                NomEquipe[4] = "Jaune";
                NomEquipe[5] = "Blanc";
                NomEquipe[6] = "Bleu";
                NomEquipe[7] = "Violet"; 
                NomEquipe[8] = "Rose"; 
                
                int nbJoueurParEquipe[NbEquipe];
                int ScoreEquipe[NbEquipe] ;
                int ordreEquipe[NbEquipe] ;
                
                for (i=0;i<NbEquipe;i++) nbJoueurParEquipe[i]=0;
                for (i=0;i<NbEquipe;i++) ScoreEquipe[i]=0;
                for (i=0;i<NbEquipe;i++) ordreEquipe[i]=i;
                
                for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
                   if(!gpJeu->getAutreJoueur(i)->estInvisible())
                   {
                       nbJoueurParEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]++;
                       ScoreEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]+=gpJeu->getAutreJoueur(i)->getScore();
                   }
               
                gpJeu->fct.tri_rapide2T(ScoreEquipe, ordreEquipe, NbEquipe);
                pos = 36;
                for(i=0 ; i<NbEquipe ; i++)
                {
                   if (nbJoueurParEquipe[ordreEquipe[NbEquipe-i-1]]!=0)
                   {
                       tmpScore = ScoreEquipe[NbEquipe-i-1];
                       
                       if (nbJoueurParEquipe[ordreEquipe[NbEquipe-i-1]]<2)
                          gpJeu->affiche(gpScreen, NomEquipe[ordreEquipe[NbEquipe-i-1]]+" - "+gpJeu->fct.int2string(nbJoueurParEquipe[ordreEquipe[NbEquipe-i-1]])+" Joueur", 148,pos-dec+8);
                       else
                          gpJeu->affiche(gpScreen, NomEquipe[ordreEquipe[NbEquipe-i-1]]+" - "+gpJeu->fct.int2string(nbJoueurParEquipe[ordreEquipe[NbEquipe-i-1]])+" Joueurs", 148,pos-dec+8);
                       
                       if (tmpScore >= 0 && tmpScore < 10)
                           gpJeu->affiche(gpScreen, gpJeu->fct.int2string(ScoreEquipe[NbEquipe-i-1]), 284,pos-dec+8);
                       
                       if (tmpScore >= 10 && tmpScore < 100)
                           gpJeu->affiche(gpScreen, gpJeu->fct.int2string(ScoreEquipe[NbEquipe-i-1]), 278,pos-dec+8);
                          
                       if (tmpScore >= 100 && tmpScore < 1000)
                           gpJeu->affiche(gpScreen, gpJeu->fct.int2string(ScoreEquipe[NbEquipe-i-1]), 272,pos-dec+8);
                       
                       if (tmpScore < 0 || tmpScore >= 1000)
                           gpJeu->affiche(gpScreen, gpJeu->fct.int2string(ScoreEquipe[NbEquipe-i-1]), 266,pos-dec+8);
                      
                      pos+=16;
                  }
                }
          }
      break;
      }
                
}  

void Partie::FinPartie()
{
     int i;
     
      switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
      case 2 : //VOL DE RUBIS
      case 4 : //Bonus Couleur
      case 5 : //le fantome
      case 6 : //Only sword
          {
             //YOUHOU
           
           //gpJeu->setMessage("En cours", 1);
             for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
             {
               if(!gpJeu->getAutreJoueur(i)->estInvisible())
               {
                 if(gpJeu->getAutreJoueur(i)->getScore() >= getLimiteVal())
                 {
             //      gpJeu->setMessage("Fini", 1);
                     jeuFini=1;
                 }
               }
             }    
          }
      break; 
      case 1 : //EQUIPE
      case 3 : //PRV
      case 7 : //Team only sword
          { 
               int ScoreEquipe[NbEquipe] ;
               for (i=0;i<NbEquipe;i++) ScoreEquipe[i]=0;
               
               for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
                   if(!gpJeu->getAutreJoueur(i)->estInvisible())
                   {
                       ScoreEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]+=gpJeu->getAutreJoueur(i)->getScore();
                   }
               
               for (i=0; i<NbEquipe ; i++)
               {
                 if(ScoreEquipe[i] >= getLimiteVal())
                     jeuFini=1;
               }
          }    
      }    
}

int Partie::getJeuFini()
{
    return jeuFini;
}

void Partie::setJeuFini(int i)
{
    jeuFini = i;
}



//retourne le score du dernier
int Partie::scoreMin()
{
     int i;

     int minScore = getLimiteVal();
     
      switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
      case 2 : //VOL DE RUBIS
      case 4 : //Bonus Couleur
      case 5 : //Le Fantome
      case 6 : //Only sword
          {
             for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
             {
               if(!gpJeu->getAutreJoueur(i)->estInvisible())
               {
                 if(gpJeu->getAutreJoueur(i)->getScore() < minScore)
                 {
                     minScore = gpJeu->getAutreJoueur(i)->getScore();
                 }
               }
             }    
          }
      break; 
      case 1 : //EQUIPE
      case 3 : //PRV
      case 7 : //Team only sword
          { 
               int ScoreEquipe[NbEquipe] ;
               int NbJoureurEquipe[NbEquipe];
               
               for (i=0;i<NbEquipe;i++) ScoreEquipe[i]=0;
               for (i=0;i<NbEquipe;i++) NbJoureurEquipe[i]=0;
               
               for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
                   if(!gpJeu->getAutreJoueur(i)->estInvisible())
                   {
                       NbJoureurEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]++;
                       ScoreEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]+=gpJeu->getAutreJoueur(i)->getScore();
                   }
               
               for (i=0; i<NbEquipe ; i++)
               {
                   if(NbJoureurEquipe[i] != 0 && ScoreEquipe[i] < minScore)
                   {
                     minScore = ScoreEquipe[i];
                   }
               }
          }    
      } 
      
      return minScore;
}

//retour mes meilleurs scores des autres joueurs
int Partie::scoreMaxSauf(int numJ)
{
     int i;
     
     int maxScore = 0;
     
     for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
     {
       if(!gpJeu->getAutreJoueur(i)->estInvisible() && numJ!=gpJeu->getAutreJoueur(i)->getNumero())
       {
         if(gpJeu->getAutreJoueur(i)->getScore() > maxScore)
         {
             maxScore = gpJeu->getAutreJoueur(i)->getScore();
         }
       }
     } 
     
     return maxScore;
}

//retourne le score du premier
int Partie::scoreMax()
{
     int i;

     int maxScore = 0;
     
      switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
      case 2 : //VOL DE RUBIS
      case 4 : //Bonus Couleur
      case 5 : //Le Fantome
      case 6 : //Only sword
          {
             for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
             {
               if(!gpJeu->getAutreJoueur(i)->estInvisible())
               {
                 if(gpJeu->getAutreJoueur(i)->getScore() > maxScore)
                 {
                     maxScore = gpJeu->getAutreJoueur(i)->getScore();
                 }
               }
             }    
          }
      break; 
      case 1 : //EQUIPE
      case 3 : //PRV
      case 7 : //Team only sword
          { 
               int ScoreEquipe[NbEquipe] ;
               int NbJoureurEquipe[NbEquipe];
               
               for (i=0;i<NbEquipe;i++) ScoreEquipe[i]=0;
               for (i=0;i<NbEquipe;i++) NbJoureurEquipe[i]=0;
               
               for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
                   if(!gpJeu->getAutreJoueur(i)->estInvisible())
                   {
                       NbJoureurEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]++;
                       ScoreEquipe[gpJeu->getAutreJoueur(i)->getCouleur()]+=gpJeu->getAutreJoueur(i)->getScore();
                   }
               
               for (i=0; i<NbEquipe ; i++)
               {
                   if(NbJoureurEquipe[i] != 0 && ScoreEquipe[i] > maxScore)
                   {
                     maxScore = ScoreEquipe[i];
                   }
               }
          }    
      } 
      
      return maxScore;
}

//retourne le score du joueur
int Partie::scoreJoueur()
{
     int i;

     int JoueurScore = 0;
     
      switch(TypeJeu) {
      case 0 : //CHACUN POUR SOI 
      case 2 : //VOL DE RUBIS
      case 4 : //Bonus Couleur
      case 5 : //Le Fantome
      case 6 : //Only sword
          {
                 JoueurScore = gpJeu->getJoueur()->getScore();
          }
      break; 
      case 1 : //EQUIPE
      case 3 : //PRV
      case 7 : //Team only sword
          { 
               int ScoreEquipe=0 ;
               
               for (i=0;i <gpJeu->getNbAutreJoueur(); i++)
                   if(!gpJeu->getAutreJoueur(i)->estInvisible() && gpJeu->getAutreJoueur(i)->getCouleur()==gpJeu->getJoueur()->getCouleur())
                   {
                       ScoreEquipe+=gpJeu->getAutreJoueur(i)->getScore();
                   }
               
               JoueurScore = ScoreEquipe;
          }    
      } 
      
      return JoueurScore;
}
